<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="/">
		<xsl:variable name="doc" select="document('books.xml')" />
		<html>
			<head><title>Authors</title></head>
			<body>
				<table border="1">
					<tr>
						<th>Author name</th>
						<th>Number of books</th>
					</tr>
					<xsl:for-each select="$doc//Author[not(@Name = preceding::Author/@Name)]">
						<xsl:sort select="@Name" order="descending" />
						<xsl:variable name="n" select="@Name"/>
						<tr>
							<td><xsl:value-of select="@Name"/></td>
							<td><xsl:value-of select="count($doc//Book[Author/@Name = $n])"/></td>
						</tr>
					</xsl:for-each>
				</table>
			</body>
		</html>
	</xsl:template>
</xsl:transform>
