<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform version="3.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="xml"/>
	<xsl:variable name="quote">"</xsl:variable>
	<xsl:template match="/">
		<root>
			<EnglishBookSortedByYear>
				<xsl:call-template name="SortedFilteredBooks">
					<xsl:with-param name="filter" select="'@OriginalLanguage='||$quote||'English'||$quote"/>
					<xsl:with-param name="sort" select="'min(Edition/@Year)'"/>
				</xsl:call-template>
			</EnglishBookSortedByYear>
			<CarlSagansBooksByTitle>
				<xsl:call-template name="SortedFilteredBooks">
					<xsl:with-param name="filter" select="'Author/@Name='||$quote||'Carl Sagan'||$quote"/>
					<xsl:with-param name="sort" select="'@Title'"/>
				</xsl:call-template>
			</CarlSagansBooksByTitle>
			<BooksWith2001EditionByNumberOfAuthors>
				<xsl:call-template name="SortedFilteredBooks">
					<xsl:with-param name="filter" select="'Edition/@Year=2001'"/>
					<xsl:with-param name="sort" select="'count(Author)'"/>
				</xsl:call-template>
			</BooksWith2001EditionByNumberOfAuthors>
		</root>
	</xsl:template>
	<xsl:template name="SortedFilteredBooks">
		<xsl:param name="filter"/>
		<xsl:param name="sort"/>
		<xsl:variable name="books">
			<xsl:evaluate xpath="'//Book[' || $filter || ']'" context-item="."/>
		</xsl:variable>
		<xsl:for-each select="$books/Book">
			<xsl:sort>
				<xsl:evaluate xpath="$sort" context-item="."/>
			</xsl:sort>
			<Book title="{@Title}" firstEdition="{min(Edition/@Year)}"/>
		</xsl:for-each>
	</xsl:template>
</xsl:transform>
